package net.afyre.haha.demo.coq;

/**
 * The class that controls different kinds of indentation.
 * 
 * @author Aleksy Schubert <alx@mimuw.edu.pl>
 */
import java.io.Writer;
import java.util.ListIterator;
import java.util.Stack;

/**
 * 
 * @author Aleksy Schubert <alx@mimuw.edu.pl>
 *
 */
public class CoqIndent {

  /** The output to write the indentation to */
  private Writer output;

  /** The level of indentation */
  private Stack<IndentItem> level;

  /**
   * The constructor of the indentation management object.
   * 
   * @param output the output to write indents to
   */
  public CoqIndent(final Writer output) {
    this.output = output;
    this.level = new Stack<IndentItem>();
  }

  /**
   * The method to print out the current indentation.
   */
  public void print() {
    final ListIterator<IndentItem> i = level.listIterator();
    while (i.hasNext()) {
      final IndentItem e = i.next();
      e.print();
    }
  }

  /**
   * Pushes the default indentation object on the stack
   * of indentations.
   */
  public void inc() {
    level.push(new DefaultIndent(output));
  }

  /** Pops the indentation object. It does not check if the
   *  indentation stack is empty.
   */
  public void dec() {
    level.pop();
  }

}
