package net.afyre.haha.demo.rcp.hacks;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

/**
 * A handler that is always disabled.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 */
public class DisabledHandler extends AbstractHandler {
  private static final DisabledHandler instance = new DisabledHandler();
  
  public static DisabledHandler getInstance() {
    return instance;
  }
  
  protected DisabledHandler(){}
  
  /** {@inheritDoc} */
  @Override
  public Object execute(ExecutionEvent event) throws ExecutionException {
    assert false;
    return null;
  }

  /** {@inheritDoc} */
  @Override
  public boolean isEnabled() {
    return false;
  }
}
