package net.afyre.haha.demo.rcp.handlers;

import java.io.IOException;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IEditorDescriptor;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.handlers.HandlerUtil;


/**
 * Handler for the 'New' command.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 */
public class NewHandler extends AbstractHandler {
  /** {@inheritDoc} */
  @Override
  public Object execute(ExecutionEvent event) throws ExecutionException {
    final Shell shell = HandlerUtil.getActiveShellChecked(event);
    final IWorkbenchWindow window = 
        HandlerUtil.getActiveWorkbenchWindowChecked(event);
    final IWorkbenchPage page = window.getActivePage();
    final IWorkbench workbench = window.getWorkbench();
    
    final IEditorDescriptor editor = 
        workbench.getEditorRegistry().getDefaultEditor("haha.haha");
    try {
      page.openEditor(new NewFileInput(), editor.getId());
    } catch (final PartInitException e) {
      showError(shell, e);
    } catch (final IOException e) {
      showError(shell, e);
    }
    return null;
  }
 
  private void showError(final Shell shell, 
                         final Throwable e) {
    final MessageBox dialog = new MessageBox(shell, SWT.ICON_ERROR|SWT.OK);
    dialog.setMessage(e.getLocalizedMessage());  
    dialog.open();
  }
  
}
