package net.afyre.haha.demo.solver.context;

/**
 * Type of query answers.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public enum Answer {
  /** The formula is valid in current context. */ 
  VALID,
  
  /** The formula is not valid in current context. */
  INVALID,
  
  /** 
   * The solver was unable to determine 
   * the validity of the formula. 
   */
  UNKNOWN,
  
  /**
   * An error occurred. Solver might be left in an incosistent state.
   */
  ERROR;
  
  /**
   * Get the opposite answer.
   * @return Opposite answer.
   */
  public Answer neg() {
    switch (this) {
      case VALID: 
        return INVALID;
      case INVALID: 
        return VALID;
      default: 
        return this;
    }
  }
}
