package net.afyre.haha.demo.solver.expr.formulae.impl;

import net.afyre.haha.demo.solver.expr.ExpressionSwitch;
import net.afyre.haha.demo.solver.expr.formulae.Formula;
import net.afyre.haha.demo.solver.expr.formulae.FormulaSwitch;
import net.afyre.haha.demo.solver.expr.impl.AbstractExpression;


/**
 * Abstract superclass of formulae.
 * 
 * Implements forwarding of accept calls for supertypes.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public abstract class AbstractFormula extends AbstractExpression
                                      implements Formula {
  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final ExpressionSwitch<? extends Result> v) {
    return accept((FormulaSwitch<? extends Result>)v);
  }
}
