package net.afyre.haha.demo.solver.expr.formulae.impl;

import net.afyre.haha.demo.solver.expr.Expression;
import net.afyre.haha.demo.solver.expr.VariableBinding;
import net.afyre.haha.demo.solver.expr.formulae.Formula;
import net.afyre.haha.demo.solver.expr.formulae.FormulaSwitch;

/**
 * Existential quantification.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public final class Exists extends QuantifiedFormula {
  /**
   * Constructor.
   * @param variables Bound variables.
   * @param formula Formula under quantification.
   * @param patterns Instantiation patterns.
   */
  public Exists(final Iterable<VariableBinding> variables,
                final Formula formula,
                final Expression... patterns) {
    super(variables, formula, patterns);
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final FormulaSwitch<? extends Result> v) {
    return v.caseExists(getVariables(), getFormula(), getPatterns());
  }
}
