package net.afyre.haha.demo.solver.expr.formulae.impl;

import net.afyre.haha.demo.solver.expr.formulae.FormulaSwitch;

/**
 * Variable reference.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public final class FormulaVariable extends AbstractFormula {
  /** Variable name. */
  private final String name;
  
  /**
   * Constructor.
   * @param name Variable name.
   */
  public FormulaVariable(final String name) {
    this.name = name;
  }
  
  /**
   * Get the variable name.
   * @return Name.
   */
  public String getName() {
    return name;
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final FormulaSwitch<? extends Result> v) {
    return v.caseFormulaVariable(name);
  }

}
