package net.afyre.haha.demo.solver.expr.formulae.impl;

import net.afyre.haha.demo.solver.expr.formulae.FormulaSwitch;
import net.afyre.haha.demo.solver.expr.terms.Term;

/**
 * Less than or equal to.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public class Le extends Comparison {
  /**
   * Constructor.
   * @param left Left term.
   * @param right Right term.
   */
  public Le(final Term left, final Term right) {
    super(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final FormulaSwitch<? extends Result> v) {
    return v.caseLe(getLeft(), getRight());
  }
}
