package net.afyre.haha.demo.solver.expr.terms.impl;

import net.afyre.haha.demo.solver.expr.terms.Term;
import net.afyre.haha.demo.solver.expr.terms.TermSwitch;

/**
 * Array access.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 */
public final class ArrayAccess extends BinaryTerm {
  /**
   * Constructor.
   * @param array Array value.
   * @param index Index value.
   */
  public ArrayAccess(final Term array, final Term index) {
    super(array, index);
  }
  
  /**
   * Get the array value.
   * @return Array.
   */
  public Term getArray() {
    return getLeft();
  }
  
  /**
   * Get the index value.
   * @return Index.
   */
  public Term getIndex() {
    return getRight();
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final TermSwitch<? extends Result> v) {
    return v.caseArrayAccess(getArray(), getIndex());
  }
  
  
}
