package net.afyre.haha.demo.solver.expr.terms.impl;

import net.afyre.haha.demo.solver.expr.terms.Term;
import net.afyre.haha.demo.solver.expr.terms.TermSwitch;

/**
 * Remainder.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 * @see net.afyre.haha.demo.solver.expr.terms.TermSwitch#visitMultiplication
 */
public final class Remainder extends BinaryTerm {
  /**
   * Constructor.
   * @param left Left operand.
   * @param right Right operand.
   */
  public Remainder(final Term left, final Term right) {
    super(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final TermSwitch<? extends Result> v) {
    return v.caseRemainder(getLeft(), getRight());
  }
}
