package net.afyre.haha.demo.solver.expr.terms.impl;

import net.afyre.haha.demo.solver.expr.terms.Term;
import net.afyre.haha.demo.solver.expr.terms.TermSwitch;

/**
 * Vector shift left.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public final class Shl extends VectorOffsetOp {
  /**
   * Constructor.
   * @param vector Vector.
   * @param offset Shift amount
   */
  public Shl(final Term vector, final int offset) {
    super(vector, offset);
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final TermSwitch<? extends Result> v) {
    return v.caseShl(getVector(), getOffset());
  }
}
