package net.afyre.haha.demo.solver.expr.terms.impl;

import net.afyre.haha.demo.solver.expr.terms.Term;
import net.afyre.haha.demo.solver.expr.terms.TermSwitch;

/**
 * Tuple element access.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public final class TupleAccess extends AbstractTerm {
  /** Tuple value. */
  private final Term tuple;
  
  /** Index value. */
  private final int index;
  
  /**
   * Constructor.
   * @param tuple Tuple value.
   * @param index Index value.
   */
  public TupleAccess(final Term tuple, final int index) {
    this.tuple = tuple;
    this.index = index;
  }
  
  /**
   * Get the tuple value.
   * @return Array.
   */
  public Term getTuple() {
    return tuple;
  }
  
  /**
   * Get the index value.
   * @return Index.
   */
  public int getIndex() {
    return index;
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final TermSwitch<? extends Result> v) {
    return v.caseTupleAccess(tuple, index);
  }
}
