package net.afyre.haha.demo.solver.expr.types.impl;

import net.afyre.haha.demo.solver.expr.types.AtomicType;
import net.afyre.haha.demo.solver.expr.types.AtomicTypeSwitch;
import net.afyre.haha.demo.solver.expr.types.ValueTypeSwitch;

/**
 * Abstract superclass of atomic types.
 * 
 * Implements forwarding of accept calls for supertypes.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public abstract class AbstractAtomicType extends AbstractValueType 
                                         implements AtomicType {
  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final ValueTypeSwitch<? extends Result> v) {
    return accept((AtomicTypeSwitch<? extends Result>)v);
  }
}
