package net.afyre.haha.demo.ui.annotations;

import net.afyre.haha.demo.vcgen.VerificationCondition;

/**
 * Annotation for assertions for which the solver answer was "UNKNOWN".
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public class UnknownAssertAnnotation extends ConditionAnnotation {
  /** Annotation type. */
  public static final String ID = "net.afyre.haha.demo.ui.unknownassert";
  
  /**
   * Constructor.
   * @param condition The condition that caused the problem.
   */
  public UnknownAssertAnnotation(final VerificationCondition condition) {
    super(ID, condition);
  }
  
  /**
   * Return text created from VC context and model.
   * @return Text.
   */
  @Override
  public String getText() {
    String msg = "Unable to prove validity of a condition.\n";
    msg += getVCDescription();
    return msg;
  }  
}
