package net.afyre.haha.demo.ui.handler;

import net.afyre.haha.demo.solver.SolverRunningState;
import net.afyre.haha.demo.ui.HahaSourceProvider;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.ui.handlers.HandlerUtil;
import org.eclipse.ui.services.ISourceProviderService;

/**
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 */
public class StopHandler extends AbstractHandler implements IHandler {

  /** {@inheritDoc} */
  @Override
  public Object execute(final ExecutionEvent event) throws ExecutionException {
    final ISourceProviderService sourceProviderService = 
        (ISourceProviderService) 
          HandlerUtil.getActiveWorkbenchWindow(event).getService(
            ISourceProviderService.class);
    final HahaSourceProvider sourceProvider = 
        (HahaSourceProvider) sourceProviderService.getSourceProvider(
          HahaSourceProvider.VAR_RUNNING);
    final Thread thread = sourceProvider.getThread();  
    if (thread != null) {
      thread.interrupt();
    }
    SolverRunningState.killActiveVerificationProcesses();
    sourceProvider.setRunning(false);
    
    return null;
  }

}
