/*
 * generated by Xtext
 */
package net.afyre.haha.demo.formatting;

import net.afyre.haha.demo.services.HahaGrammarAccess;

import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.formatting.impl.AbstractDeclarativeFormatter;
import org.eclipse.xtext.formatting.impl.FormattingConfig;
import org.eclipse.xtext.util.Pair;

/**
 * This class contains custom formatting description.
 * 
 * see : http://www.eclipse.org/Xtext/documentation/latest/xtext.html#formatting
 * on how and when to use it 
 * 
 * Also see {@link org.eclipse.xtext.xtext.XtextFormattingTokenSerializer} as an example
 */
public class HahaFormatter extends AbstractDeclarativeFormatter {
	
  @Override
  protected void configureFormatting(final FormattingConfig c) {
    final HahaGrammarAccess g = (HahaGrammarAccess) getGrammarAccess();
    
    // No spaces around parentheses.
    for (Pair<Keyword, Keyword> pair : g.findKeywordPairs("(", ")")) {
      c.setNoSpace().after(pair.getFirst());
      c.setNoSpace().before(pair.getSecond());
    }
    for (Pair<Keyword, Keyword> pair : g.findKeywordPairs("[", "]")) {
      c.setNoSpace().after(pair.getFirst());
      c.setNoSpace().before(pair.getSecond());
    }
    for (Keyword comma : g.findKeywords(",")) {
      c.setNoSpace().before(comma);
    }    
    
    for (final Pair<Keyword, Keyword> pair : 
         g.findKeywordPairs("begin", "end")) {     
      c.setIndentation(pair.getFirst(), pair.getSecond());
      c.setLinewrap().after(pair.getFirst());
      c.setLinewrap().after(pair.getSecond());
      c.setLinewrap().before(pair.getFirst());
      c.setLinewrap().before(pair.getSecond());
    }
    c.setLinewrap().before(g.getLocalsAccess().getVarKeyword_0());
    c.setLinewrap().after(g.getStatementAccess().getRule());
    c.setLinewrap().after(g.getLocalRule());
    c.setLinewrap().after(g.getPreconditionRule());
    c.setLinewrap().after(g.getPostconditionRule());
    c.setLinewrap().after(g.getLoopInvariantRule());
    c.setLinewrap().after(g.getLoopAccess().getDoKeyword_2());
    c.setLinewrap().after(g.getCondAccess().getThenKeyword_2());
    
    c.setIndentationIncrement().after(g.getLoopAccess().getDoKeyword_2());
    
    // Add and preserve newlines around comments
    c.setLinewrap(0, 1, 2).before(g.getSL_COMMENTRule());
    c.setLinewrap(0, 1, 2).before(g.getML_COMMENTRule());
    c.setLinewrap(0, 1, 1).after(g.getML_COMMENTRule());
  }
}
