package net.afyre.haha.demo.types;

/**
 * Interface of objects used to inspect HAHA types.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 * 
 * @param <Result> Type of inspection result.
 */
public interface TypeSwitch<Result> extends ValueTypeSwitch<Result> {
  /**
   * Function type.
   * @param resultType Result type.
   * @param argTypes Types of the arguments.
   * @return Switch result.
   */
  Result caseFunction(ValueType resultType, ValueType... argTypes);
}
