package net.afyre.haha.demo.vcgen;

import java.util.List;

import net.afyre.haha.demo.haha.SimpleStatement;

/**
 * Interface of verification condition generators
 * for simple statements (i.e. for statements which
 * do not contain other statements).
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public interface SimpleStatementVCGen {
  /**
   * Generate verification conditions for a statement.
   * @param context Parent context for the generated condition.
   * @param preconditions List of preconditions.
   * @param stmt Statement.
   * @param postconditions List of postconditions.
   * @param consumer Object used to process generated conditions.
   */
  void  generateVerificationConditions(
      VCContext context,
      List<DocumentedFormula> preconditions,
      SimpleStatement stmt,
      List<DocumentedFormula> postconditions, 
      VCConsumer consumer);
}
