package net.afyre.haha.demo.vcgen.tree;

/**
 * Interface of switches used to deconstruct tree nodes.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 * @param <T> Type of values returned by the switch.
 */
public interface NodeSwitch<T> {
  /**
   * Method invoked by nodes that store context data.
   * @param node Node with context data.
   * @return Switch result.
   */
  T caseContext(ContextNode node);

  /**
   * Method invoked by nodes that store condition data.
   * @param node Node with condition data.
   * @return Switch result.
   */
  T caseCondition(ConditionNode node);
}
